'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cleanReactProps = require('clean-react-props');

var _cleanReactProps2 = _interopRequireDefault(_cleanReactProps);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

require('jquery.ripples');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WaterEffect = function (_Component) {
  _inherits(WaterEffect, _Component);

  function WaterEffect() {
    var _temp, _this, _ret;

    _classCallCheck(this, WaterEffect);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.destroy = function () {
      _this.target.ripples('destroy');
    }, _this.drop = function () {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
        x: undefined,
        y: undefined,
        radius: undefined,
        strength: undefined
      },
          _ref$x = _ref.x,
          x = _ref$x === undefined ? undefined : _ref$x,
          _ref$y = _ref.y,
          y = _ref$y === undefined ? undefined : _ref$y,
          _ref$radius = _ref.radius,
          radius = _ref$radius === undefined ? undefined : _ref$radius,
          _ref$strength = _ref.strength,
          strength = _ref$strength === undefined ? undefined : _ref$strength;

      _this.target.ripples('drop', x, y, radius, strength);
    }, _this.pause = function () {
      _this.target.ripples('pause');
    }, _this.play = function () {
      _this.target.ripples('play');
    }, _this.hide = function () {
      _this.target.ripples('hide');
    }, _this.show = function () {
      _this.target.ripples('show');
    }, _this.set = function () {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
        property: undefined,
        value: undefined
      },
          _ref2$property = _ref2.property,
          property = _ref2$property === undefined ? undefined : _ref2$property,
          _ref2$value = _ref2.value,
          value = _ref2$value === undefined ? undefined : _ref2$value;

      _this.target.ripples('set', property, value);
    }, _this.updateSize = function () {
      _this.target.ripples('updateSize');
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  WaterEffect.prototype.componentDidMount = function componentDidMount() {
    var _props = this.props,
        imageUrl = _props.imageUrl,
        dropRadius = _props.dropRadius,
        perturbance = _props.perturbance,
        resolution = _props.resolution,
        interactive = _props.interactive,
        crossOrigin = _props.crossOrigin;

    this.target = (0, _jquery2.default)(this.el);

    this.target.ripples({
      imageUrl: imageUrl,
      dropRadius: dropRadius,
      perturbance: perturbance,
      resolution: resolution,
      interactive: interactive,
      crossOrigin: crossOrigin
    });
  };

  WaterEffect.prototype.componentWillUnmount = function componentWillUnmount() {
    this.target.ripples('destroy');
  };

  WaterEffect.prototype.render = function render() {
    var _this2 = this;

    var children = this.props.children;


    return _react2.default.createElement(
      'div',
      _extends({
        ref: function ref(el) {
          _this2.el = el;
        }
      }, (0, _cleanReactProps2.default)(this.props)),
      children({
        destroy: this.destroy,
        pause: this.pause,
        play: this.play,
        hide: this.hide,
        show: this.show,
        drop: this.drop,
        set: this.set,
        updateSize: this.updateSize
      })
    );
  };

  return WaterEffect;
}(_react.Component);

WaterEffect.propTypes = process.env.NODE_ENV !== "production" ? {
  imageUrl: _propTypes2.default.string,
  dropRadius: _propTypes2.default.number,
  perturbance: _propTypes2.default.number,
  resolution: _propTypes2.default.number,
  interactive: _propTypes2.default.bool,
  crossOrigin: _propTypes2.default.string,
  children: _propTypes2.default.func
} : {};

WaterEffect.defaultProps = {
  imageUrl: null,
  dropRadius: 20,
  perturbance: 0.03,
  resolution: 256,
  interactive: true,
  crossOrigin: '',
  children: function children() {}
};

exports.default = WaterEffect;
module.exports = exports['default'];